<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
  <head>
    <title>Metadata API Introduction</title>
  </head>

  <body>
    <center><h1>Metadata API Introduction</h1></center><br>

	<p>The metadataAPI is the LDAS custom Database Client used to
	   interface with the LIGO Database server in the LDAS distributed
	   computing environment. It will use an interpreted command
	   language for control. It will provide for all database functions
	   such as table creation, inserts, queries, etc.
   
	<p>The Metadata API is divided into two layers, the TCL layer and
	   the C++ layer. The TCL layer is what the end-user "sees" -- they
	   write code which the TCL layer executes. The C++ layer, on the
	   other hand, is available only indirectly.

        <p>TCL provides a mechanism for extending the command-set by writing
	   functions in C or C++.  These functions are loaded into TCL as a
	   shared object using the "package require" or "load" command.
	   When this is done, the extended commands become available.
	   The C++ layer consists of these extended commands and the memory
	   space which they use to store and manipulate data.

	<p>In order to create C or C++ functions which TCL can understand,
	   one must write them in a special format.  In LDAS, this is handled
	   by a program known as SWIG (Simplified Wrapper and Interface
	   Generator).  The SWIG program uses 1 or more SWIG interface
	   files to create a set of C functions which TCL can understand.
	   These functions are written to a source file (.c or .cc) which
	   is then compiled into the shared object.

	<p>This document is divided into the following areas:
	<p><ol>
	  <li><A href="#tcl_pointers">Pointers in TCL</A></li>
	</ol>
	
	<br><hr>
	<A name="tcl_pointers"></A>
	<h2>1. Pointers in TCL</h2>
	<p>The metadata API creates objects in the C++ layer which need to
	   be manipulated by TCL.  In order to do so, each of these objects
	   must have a unique label.  The pointer value of the object in the
	   C++ layer is used as the label.  This value is converted by SWIG
	   into an ascii representation of the pointer with the format:
	
	<p>_<font color="#3366FF">xxxxxxxx</font>_<font color="#3366FF">ObjectName</font>_p

	<p>where:<ol>
	  <li><font color="#3366FF">xxxxxxxx</font>
	      is a hexadecimal number representing the pointer value
	      (it may have fewer than 8 characters). For example a dbEasy
	      object may appear as:
	  	<p>_555f0_dbEasy_p
		<p>
          <li><font color="#3366FF">ObjectName</font>
	      is the name of the C++ class object to be referenced
	      and may have the value of <font color="#009900">dbEasy</font>
	       or <font color="#009900">dbEasyStmt</font>.
	</ol>

	<p><hr>
	<A name="ligolwelements"></A>
    <address><a href="mailto:emaros@ligo.caltech.edu">Ed Maros</a>
    </address>
    <!-- Created:Thu Mar 16 08:04:04 PST 2000 -->
    Last modified: <!--#ECHO VAR="LAST_MODIFIED"-->
  </body>
</html>
